Перейти до основного вмісту
POST
/
v1beta
/
models
/
{model}
:
{operator}
from google import genai

client = genai.Client(
    api_key="<COMETAPI_KEY>",
    http_options={"api_version": "v1beta", "base_url": "https://api.cometapi.com"},
)

response = client.models.generate_content(
    model="gemini-2.5-flash",
    contents="Explain how AI works in a few words",
)

print(response.text)
{
  "candidates": [
    {
      "content": {
        "role": "<string>",
        "parts": [
          {
            "text": "<string>",
            "functionCall": {
              "name": "<string>",
              "args": {}
            },
            "inlineData": {
              "mimeType": "<string>",
              "data": "<string>"
            },
            "thought": true
          }
        ]
      },
      "finishReason": "STOP",
      "safetyRatings": [
        {
          "category": "<string>",
          "probability": "<string>",
          "blocked": true
        }
      ],
      "citationMetadata": {
        "citationSources": [
          {
            "startIndex": 123,
            "endIndex": 123,
            "uri": "<string>",
            "license": "<string>"
          }
        ]
      },
      "tokenCount": 123,
      "avgLogprobs": 123,
      "groundingMetadata": {
        "groundingChunks": [
          {
            "web": {
              "uri": "<string>",
              "title": "<string>"
            }
          }
        ],
        "groundingSupports": [
          {
            "groundingChunkIndices": [
              123
            ],
            "confidenceScores": [
              123
            ],
            "segment": {
              "startIndex": 123,
              "endIndex": 123,
              "text": "<string>"
            }
          }
        ],
        "webSearchQueries": [
          "<string>"
        ]
      },
      "index": 123
    }
  ],
  "promptFeedback": {
    "blockReason": "SAFETY",
    "safetyRatings": [
      {
        "category": "<string>",
        "probability": "<string>",
        "blocked": true
      }
    ]
  },
  "usageMetadata": {
    "promptTokenCount": 123,
    "candidatesTokenCount": 123,
    "totalTokenCount": 123,
    "trafficType": "<string>",
    "thoughtsTokenCount": 123,
    "promptTokensDetails": [
      {
        "modality": "<string>",
        "tokenCount": 123
      }
    ],
    "candidatesTokensDetails": [
      {
        "modality": "<string>",
        "tokenCount": 123
      }
    ]
  },
  "modelVersion": "<string>",
  "createTime": "<string>",
  "responseId": "<string>"
}

Огляд

CometAPI підтримує нативний формат API Gemini, надаючи вам повний доступ до специфічних для Gemini можливостей, таких як керування thinking, Google Search grounding, нативні модальності генерації зображень та інше. Використовуйте цей endpoint, коли вам потрібні можливості, недоступні через OpenAI-compatible chat endpoint.

Швидкий старт

Замініть base URL та API key у будь-якому Gemini SDK або HTTP-клієнті:
НалаштуванняЗначення Google за замовчуваннямCometAPI
Base URLgenerativelanguage.googleapis.comapi.cometapi.com
API Key$GEMINI_API_KEY$COMETAPI_KEY
Для автентифікації підтримуються як заголовки x-goog-api-key, так і Authorization: Bearer.

Thinking (Reasoning)

Моделі Gemini можуть виконувати внутрішнє reasoning перед генерацією відповіді. Спосіб керування залежить від покоління моделі.
Моделі Gemini 3 використовують thinkingLevel для керування глибиною reasoning. Доступні рівні: MINIMAL, LOW, MEDIUM, HIGH.
curl "https://api.cometapi.com/v1beta/models/gemini-3.1-pro-preview:generateContent" \
  -H "Content-Type: application/json" \
  -H "x-goog-api-key: $COMETAPI_KEY" \
  -d '{
    "contents": [{"parts": [{"text": "Explain quantum physics simply."}]}],
    "generationConfig": {
      "thinkingConfig": {"thinkingLevel": "LOW"}
    }
  }'
Використання thinkingLevel з моделями Gemini 2.5 (або thinkingBudget з моделями Gemini 3) може спричинити помилки. Використовуйте правильний параметр для вашої версії моделі.

Streaming

Використовуйте streamGenerateContent?alt=sse як оператор, щоб отримувати Server-Sent Events у процесі генерації контенту моделлю. Кожна SSE-подія містить рядок data: з JSON-об’єктом GenerateContentResponse.
curl "https://api.cometapi.com/v1beta/models/gemini-2.5-flash:streamGenerateContent?alt=sse" \
  -H "Content-Type: application/json" \
  -H "x-goog-api-key: $COMETAPI_KEY" \
  --no-buffer \
  -d '{
    "contents": [{"parts": [{"text": "Write a short poem about the stars"}]}]
  }'

Системні інструкції

Спрямовуйте поведінку моделі протягом усієї розмови за допомогою systemInstruction:
curl "https://api.cometapi.com/v1beta/models/gemini-2.5-flash:generateContent" \
  -H "Content-Type: application/json" \
  -H "x-goog-api-key: $COMETAPI_KEY" \
  -d '{
    "contents": [{"parts": [{"text": "What is 2+2?"}]}],
    "systemInstruction": {
      "parts": [{"text": "You are a math tutor. Always show your work."}]
    }
  }'

JSON Mode

Примусово задайте структурований JSON-вивід за допомогою responseMimeType. За потреби також можна вказати responseSchema для суворої валідації схеми:
curl "https://api.cometapi.com/v1beta/models/gemini-2.5-flash:generateContent" \
  -H "Content-Type: application/json" \
  -H "x-goog-api-key: $COMETAPI_KEY" \
  -d '{
    "contents": [{"parts": [{"text": "List 3 planets with their distances from the sun"}]}],
    "generationConfig": {
      "responseMimeType": "application/json"
    }
  }'

Google Search Grounding

Увімкніть пошук у вебі в реальному часі, додавши інструмент googleSearch:
curl "https://api.cometapi.com/v1beta/models/gemini-2.5-flash:generateContent" \
  -H "Content-Type: application/json" \
  -H "x-goog-api-key: $COMETAPI_KEY" \
  -d '{
    "contents": [{"parts": [{"text": "Who won the euro 2024?"}]}],
    "tools": [{"google_search": {}}]
  }'
Відповідь містить groundingMetadata з URL-адресами джерел і оцінками впевненості.

Приклад відповіді

Типова відповідь від Gemini endpoint у CometAPI:
{
  "candidates": [
    {
      "content": {
        "role": "model",
        "parts": [{"text": "Hello"}]
      },
      "finishReason": "STOP",
      "avgLogprobs": -0.0023
    }
  ],
  "usageMetadata": {
    "promptTokenCount": 5,
    "candidatesTokenCount": 1,
    "totalTokenCount": 30,
    "trafficType": "ON_DEMAND",
    "thoughtsTokenCount": 24,
    "promptTokensDetails": [{"modality": "TEXT", "tokenCount": 5}],
    "candidatesTokensDetails": [{"modality": "TEXT", "tokenCount": 1}]
  },
  "modelVersion": "gemini-2.5-flash",
  "createTime": "2026-03-25T04:21:43.756483Z",
  "responseId": "CeynaY3LDtvG4_UP0qaCuQY"
}
Поле thoughtsTokenCount у usageMetadata показує, скільки токенів модель витратила на внутрішнє міркування, навіть якщо результат мислення не включено до відповіді.

Ключові відмінності від OpenAI-Compatible endpoint

ФункціяGemini Native (/v1beta/models/...)OpenAI-Compatible (/v1/chat/completions)
Керування thinkingthinkingConfig with thinkingLevel / thinkingBudgetНедоступно
Google Search groundingtools: [\{"google_search": \{\}\}]Недоступно
Google Maps groundingtools: [\{"googleMaps": \{\}\}]Недоступно
Модальність генерації зображеньresponseModalities: ["IMAGE"]Недоступно
Заголовок автентифікаціїx-goog-api-key or BearerЛише Bearer
Формат відповідіGemini native (candidates, parts)Формат OpenAI (choices, message)

Авторизації

x-goog-api-key
string
header
обов'язково

Your CometAPI key passed via the x-goog-api-key header. Bearer token authentication (Authorization: Bearer <key>) is also supported.

Параметри шляху

model
string
обов'язково

The Gemini model ID to use. See the Models page for current Gemini model IDs.

Приклад:

"gemini-2.5-flash"

operator
enum<string>
обов'язково

The operation to perform. Use generateContent for synchronous responses, or streamGenerateContent?alt=sse for Server-Sent Events streaming.

Доступні опції:
generateContent,
streamGenerateContent?alt=sse
Приклад:

"generateContent"

Тіло

application/json
contents
object[]
обов'язково

The conversation history and current input. For single-turn queries, provide a single item. For multi-turn conversations, include all previous turns.

systemInstruction
object

System instructions that guide the model's behavior across the entire conversation. Text only.

tools
object[]

Tools the model may use to generate responses. Supports function declarations, Google Search, Google Maps, and code execution.

toolConfig
object

Configuration for tool usage, such as function calling mode.

safetySettings
object[]

Safety filter settings. Override default thresholds for specific harm categories.

generationConfig
object

Configuration for model generation behavior including temperature, output length, and response format.

cachedContent
string

The name of cached content to use as context. Format: cachedContents/{id}. See the Gemini context caching documentation for details.

Відповідь

200 - application/json

Successful response. For streaming requests, the response is a stream of SSE events, each containing a GenerateContentResponse JSON object prefixed with data:.

candidates
object[]

The generated response candidates.

promptFeedback
object

Feedback on the prompt, including safety blocking information.

usageMetadata
object

Token usage statistics for the request.

modelVersion
string

The model version that generated this response.

createTime
string

The timestamp when this response was created (ISO 8601 format).

responseId
string

Unique identifier for this response.